package rmidemo;

import java.rmi.registry.Registry;
import java.rmi.registry.LocateRegistry;
import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;
import java.rmi.RemoteException;	

public class Server implements DataModelFactory {
	
    public Server() {}

   public DataModel getDataModel() throws java.rmi.RemoteException {
      try {
	 return new DataModelImpl();
      } catch (RuntimeException e) {
	 throw new RemoteException("Error on server",e);
      }
   }
	
    public static void main(String args[]) {
	
	try {
	    Server obj = new Server();
	    DataModelFactory stub 
	       = (DataModelFactory) UnicastRemoteObject.exportObject(obj, 0);

	    // Bind the remote object's stub in the registry
	    Registry registry = LocateRegistry.getRegistry();
	    registry.bind("DataModelFactory", stub);

	    System.err.println("Server ready");
	} catch (Exception e) {
	    System.err.println("Server exception: " + e.toString());
	    e.printStackTrace();
	}
    }
}

